package loderunner;

import java.awt.Image;
import java.util.Random;

/*
 * Enemy -  
 */
public class Enemy extends Man {
    
    private Man heroe;
    private static Random random;
    private Lode lode = null;
    private Hole hole = null;
    private int inHole = 0;
   
    Enemy(Image [] images,Level level,int x,int y){
        super(images,level,x,y);
        direction = dirLEFT;
        random = new Random();
        lode = null;
    }

//      
    public void setHeroe(Man h) {
        heroe = h;
    }

//     enemy?
    public boolean isKill(){
        Position hp = heroe.getPos();
        Position ep = getPos();
        if ( (Math.abs( 3 * (hp.getX() - ep.getX()) + hp.getInX() - ep.getInX()) < 3)  &&  (Math.abs( 3 * (hp.getY() - ep.getY()) + hp.getInY() - ep.getInY() ) < 3) ) return true;
        return false;
    }

//   
    private int getDirection() {
        int dir = dirSTAY;
        byte min = level.getINF();
        int x = pos.getX();
        int y = pos.getY();
        if (min >= level.getEvrAT(y - 1, x)) {min = level.getEvrAT(y - 1, x); dir = dirUP; }
        if (min >= level.getEvrAT(y + 1, x)) {min = level.getEvrAT(y + 1 , x); dir = dirDOWN; }
        if (min >= level.getEvrAT(y, x + 1)) {min = level.getEvrAT(y, x + 1); dir = dirRIGHT; }        
        if (min >= level.getEvrAT(y, x - 1)) {min = level.getEvrAT(y, x - 1); dir = dirLEFT; }
        return dir;
    }
 
 //  
    public void move() {          
        //  
        if (inHole()) {
            pos = new Position (random.nextInt(level.getWidth()), 0); 
            resetAutomat();
            inHole = 0;
            hole = null;
        }
        
        //
        if (inHole > 0) {            
            if ((hole != null) && (!hole.isClosing())) {
                if (inHole == 5) level.setBoxAT(pos.getY(), pos.getX(), Level.HOLE);
                if ((inHole >= 4) && (inHole <= 6)) pos.addInY(-1);                 
                if (inHole == 4) { 
                    direction = getDirection();                                 
                    if ((direction != dirLEFT) && (direction != dirRIGHT)) {
                        direction = dirSTAY;
                    } 
                }   
                if ((inHole >= 1) && (inHole <= 3)) step(direction);
            } else { inHole = 1;}
            inHole--;
            if (inHole == 0) hole = null;
        } else {        
            if ((pos.getInX() == 0) && (pos.getInY() == 0) && (getCellType(Z) == Level.HOLE)) {
                level.setBoxAT(pos.getY(), pos.getX(), Level.BRICK2);
                putLode();
                inHole = 40;
                hole = Hole.getHole(pos);
            } else if (!((pos.getInX() == 0) && (pos.getInY() == 0) && (getCellType(Z) == Level.BRICK2))){
                if ((pos.getInX() == 0) && (pos.getInY() == 0)) { takeLode(); direction = getDirection(); }
                A1(direction);
            }
        }
    }
        
 //       ,     
    private void takeLode() {        
        if (lode == null)
            for (int i = 0; i < level.lodes.size(); i++) {                
                if (( (Lode)level.lodes.get(i)).isEqual(pos.getX(),pos.getY()) ) {
                    if (random.nextInt(10) <= 2) {
                        lode = (Lode)level.lodes.get(i);
                        lode.setStatic(false);
                        break;
                    }
                }
                
            }
    }
 
 //   
   private void putLode() {
       if (lode != null) {
           lode.setPosition(pos.getX(), pos.getY() - 1);
           lode.setStatic(true);
           lode = null;
       }
   }
}