package loderunner;

import java.awt.*;

/*
 *   
 */
class Position {

    private int x,y;
    private int inX,inY;

    public Position(int x, int y){
        this.x = x;
	this.y = y;
	inX = 0;
        inY = 0;
    }

    public int getX(){
        return x;
    }

    public int getY(){
        return y;
    }
    public int getInX(){
        return inX;
    }
    public int getInY(){
        return inY;
    }

    public void addInX(int x){
        this.inX += x;
	if (inX == 2) { this.x++; inX = -1 ;}
	else if (inX == -2) {this.x--; inX = 1;}
    }

    public void addInY(int y){
        this.inY += y;
        if (inY == 2) { this.y++; inY = -1 ;}
        else if (inY == -2) {this.y--; inY = 1;}
    }
}

/*
 *         .
 */
public class Man {

    protected final int Z = 0;
    protected final int W = 1;
    protected final int E = 2;
    protected final int S = 3;
    protected final int N = 4;
    protected final int SW = 5;
    protected final int SE = 6;
    protected final int Sn = 7;
    protected final int Nn = 8;
    protected final int Zn = 9;

    //  A1
    private final int y11 = 11; // 
    private final int y12 = 12; // 
    private final int y13 = 13; // 
    private final int y14 = 14;
    private int state = y11;

    // 
    final static int dirSTAY = 0;
    final static int dirUP = 1;
    final static int dirDOWN = 2;
    final static int dirLEFT = 3;
    final static int dirRIGHT = 4;
    protected int direction = dirSTAY;

    protected Image [] images;
    private int pstate;
    protected int imageState;

    protected Position pos;
    final static int cellSize = 16;
    protected Level level;

    protected int   po=-1;

    public Man(Image [] images,Level level,int x,int y){
        this.images = images;
        pos = new Position (x,y);
        imageState = 0;
        pstate = 0;
        this.level = level;
    }

    // 
    public void draw(Graphics g){
        //g.setXORMode (Color.black);
        g.drawImage(images[imageState],cellSize*pos.getX() + Math.round(pos.getInX()*(float)5.5),cellSize*pos.getY() +  Math.round(pos.getInY()*(float)5.5),null);        
    }

    //   
    public void step(int dir){

	    int sign = 1;
        if (dir != dirRIGHT) sign = -1;

        if (pstate == 0) pstate = 2 * sign;
        else pstate = sign * (Math.abs(pstate) % 3 + 1);

        if (pstate > 0) {
            pos.addInX(1);
            imageState = pstate;
        } else {
            pos.addInX(-1);
            imageState = 3 + Math.abs(pstate);
        }
    }

	//  
    public Position getPos(){
        return pos;
    }

    //   Man'
    protected int dest(Position a, Position b){
        if ((Math.abs(3 * a.getX() + a.getInX() - 3 * b.getX() - b.getInX()) < 3) && (Math.abs(3 * a.getY() + a.getInY() - 3 * b.getY() - b.getInY()) < 3)) return 0;
        return 1;
    }

    //   Man  ?
    protected boolean inHole(){
        int y = this.getPos().getY();
        int x = this.getPos().getX();
        for (int i = -1; i <= 1; i++) {
            for (int j = -1; j <= 1; j++) {
            if ( level.getBoxAT(y + j, x + i) == Level.BRICK1)
                if (dest(this.getPos(), new Position (getPos().getX() + i, getPos().getY() + j)) < 1){ return true;}
            }
        }
        return false;
    }

    //  
    public void setPos(Position p) {
        pos = p;
    }

    //     
    protected int getCellType(int c){
        switch (c) {
            case Z:  return level.getBoxAT(pos.getY(), pos.getX());
            case E:  return level.getBoxAT(pos.getY(), pos.getX() + 1);
            case W:  return level.getBoxAT(pos.getY(), pos.getX() - 1);
            case S:  return level.getBoxAT(pos.getY() + 1, pos.getX() );
            case N:  return level.getBoxAT(pos.getY() - 1, pos.getX() );
            case SE: return level.getBoxAT(pos.getY() + 1, pos.getX() + 1);
            case SW: return level.getBoxAT(pos.getY() + 1, pos.getX() - 1);
            case Sn: return level.getBoxAT(pos.getY() + 1, pos.getX() + pos.getInX());
            case Zn: return level.getBoxAT(pos.getY(), pos.getX() + pos.getInX());
            default : return Level.EMPTY;
        }
    }

//----------------------------------------------------------------------------------------
//---   A1-------------------------------------------------------
//----------------------------------------------------------------------------------------

//  ?
    protected boolean xl(){
        if (direction == dirLEFT) return true;
        else return false;
    }

//  ?
    protected boolean xr(){
        if (direction == dirRIGHT) return true;
        else return false;
    }

//      
//   (EMPTY)?
    protected boolean xc0(int c){
        if ((getCellType(c) == Level.EMPTY) || (getCellType(c) == Level.HOLE)) return true;
        else return false;

    }
//  BRICK1?
    protected boolean xc1(int c){
        if (getCellType(c) == Level.BRICK1) return true;
        else return false;
    }

//  BRICK2?
    protected boolean xc2(int c){
        if (getCellType(c) == Level.BRICK2) return true;
        else return false;
    }

//  STAIRS?
    protected boolean xc3(int c){
        if (getCellType(c) == Level.STAIRS) return true;
        else return false;
    }

//  ROW?
    protected boolean xc4(int c){
        if (getCellType(c) == Level.ROW) return true;
        else return false;
    }

//     : , ,  
    protected boolean xp(int p) {
        switch (p) {
            case Z: if (pos.getInX() == 0 ) return true; break;
            case W: if (pos.getInX() == -1) return true; break;
            case E: if (pos.getInX() == 1) return true; break;
        }
        return false;
    }

//     : , ,  
    protected boolean xpy(int p) {
        switch (p) {
            case S: if (pos.getInY() == 1) return true;
            case Z: if (pos.getInY() == 0) return true;
        }
        return false;
    }

//----------------------------------------------------------------------------------------
//--   A1------------------------------------------------------
//----------------------------------------------------------------------------------------

//  
    protected void zu() {
        Game.logger.log(2,"zu -  ");
        po++; pos.addInY(+1); imageState = 13 + po;
        if (1==po) po=-1;
    }

//  
    protected void zd() {
        Game.logger.log(2,"zu -  ");
        po++; pos.addInY(-1); imageState = 13 + po;
        if (1==po) po=-1;
    }

//    
    protected void zy (int d) {
        Game.logger.log(2,"zy -    ");
        switch (d) {
            case S: pos.addInY(+1); direction = dirDOWN; break;
            case N: pos.addInY(-1); direction = dirUP; break;
        }
    }

//    3
    protected void z03() {
        Game.logger.log(2,"z03 -    3");
        po++;
        imageState = 13 + po;
        if (1==po) po=-1;
    }

//   
    protected void zf() {
        Game.logger.log(2,"zf -   ");
        imageState = 0;
        pos.addInY(+1);
    }

//   
    protected void zs(int d){
        Game.logger.log(2,"zs -   ");
        int p = dirSTAY;
        if (d == W) p = dirLEFT;
        else if (d == E) p = dirRIGHT;
        step(p);
        direction  = p;
    }

//  
    private void zh(int j) {
        Game.logger.log(2,"zh -  ");
        switch (j) {
            case SE:
                level.newHole (pos.getY()+1, pos.getX() + 1);
                break;
            case S:
                level.newHole (pos.getY()+1, pos.getX());
                break;
            case SW:
                level.newHole (pos.getY()+1, pos.getX() - 1);
                break;
        }
    }

//  
    private void zi(int i) {
        if (i < 0) imageState = 0;
        else imageState += i;
    }


//----------------------------------------------------------------------------------------
//-- :  ---------------------------------------------------
//----------------------------------------------------------------------------------------
    public void A1(final int e){
        Game.logger.log(1," A1    ", e);
        int oldstate  = state;
        switch (state) {
            case y11:  // 
                if (inHole()) { state = y11; break;}
                if (xp(Z) && (xc0(S) || xc4(S)) && !xc3(Z)) { //Fly //****
                    state = y14;
                    break;
                }

                if ((xc0(S) || xc4(S)) && (xc0(Sn) || xc4(Sn)) && !(xc3(Z) || xc3(Zn))) { //Fly //****
                    state = y14;
                    break;
                }

                if (e == Game.e05 && xl() && !xp(E) &&  xc1(SW) && !xc1(W) && !xc2(W)) {
                    zh(SW);
                    break;
                }

                if (e == Game.e05 && xl() && xp(E) && xc1(S)) {
                    zh(S);
                    break;
                }

                if (e == Game.e05 && xr() && !xp(E) &&  xc1(SW) && !xc1(W) && !xc2(W)) {
                    zh(SW);
                    break;
                }

                if (e == Game.e05 && xr() && xp(E) && xc1(S)) {
                    zh(S);
                    break;
                }

                if (e == Game.e03 && xp(E)) {
                    zs(W);
                    break;
                }

                if (e == Game.e03 && !xp(E) && !xc1(W) && !xc2(W)) {
                    zs(W);
                    break;
                }

                if (e == Game.e04 && xp(W)) {
                    zs(E);
                    break;
                }

                if (e == Game.e04 && !xp(W) && !xc1(E) && !xc2(E)) {
                    zs(E);
                    break;
                }

                if (e == Game.e01 && xp(Z) && !xc1(N) && !xc2(N) && xc3(Z)) {
                    zy(N);
                    state = y13;
                    break;
                }

                if (e == Game.e02 && xp(Z) && (xc3(S) || xc0(S))) {
                    zy(S);
                    state = y13;
                    break;
                }
            break;

            case y12:	// 
                if (e == Game.e02 && xc0(S) && xc0(Sn)) {
                    zy(S);
                    state = y14;
                    break;
                }
                if (e == Game.e02 &&  !(xc0(S) && xc0(Sn))) {
                    state = y11;
                    break;
                }

                if (xp(Z) && !xc4(Z) && (xc1(S) || xc2(S) || xc3(S) || xc3(Z))) {
                    state = y11;
                    break;
                }

                if (xp(Z) && !xc4(Z) && !(xc1(S) || xc2(S) || xc3(S) || xc3(Z))) {
                    state = y14;
                    break;
                }

                if (e == Game.e03 && xp(E)) {
                    zs(W);
                    zi(6);
                    break;
                }

                if (e == Game.e03 && !xp(E) && !xc1(W) && !xc2(W)) {
                    zs(W);
                    zi(6);
                    break;
                }

                if (e == Game.e04 && xp(W)) {
                    zs(E);
                    zi(6);
                    break;
                }

                if (e == Game.e04 && !xp(W) && !xc1(E) && !xc2(E)) {
                    zs(E);
                    zi(6);
                    break;
                }
            break;

            case y13:	// 
                if (e == Game.e01 && (xpy(S) || (!xc1(N) && !xc2(N)))) zd();
                if (e == Game.e02) {zu();}
                if (xpy(Z)) state = y11; //****
            break;

            case y14:	//
                if (xpy(Z) &&(xc1(S) || xc2(S)  || xc3(S) || xc1(Sn) || xc2(Sn) || xc3(Sn))) {
                    state = y11;
                    break;
                }
                if (xpy(Z) && xc4(Z)) {
                    state = y12;
                    break;
                }
                zf();
            break;
        }

        if (oldstate != state) {
            Game.logger.log(" A1    y" + oldstate + "  " + state);
            switch (state){
                case y11:
                    zi(-1);
                break;
                case y12:
                    zi(-1);
                break;

                case y13:
                    z03();
                break;

                case y14:
                break;
            }
        }

        Game.logger.log(1," A1    ", e);
    }

//  
    public void resetAutomat () {
        state = y11;
        imageState = 0;
    }
}